MSCZJOBS	;JKT/MSC - OpenVista System status ;24AUG2009
	;;8.0;KERNEL;**MSC**
	;
ALL	D SS() Q
THIS	D SS(1) Q
	;
SS(THIS) ;Print GT.M mumps processes
	; If THIS is true, only print processes associated with the current
	; OpenVista instance
	;
	Q:$G(^%ZOSF("OS"))'["GT.M"
	;
	D INTRPT^MSCZJOBU("*") H .5
	;
	N DATETIME S DATETIME=$$HTE^XLFDT($H)
	W #!,?28,"OpenVista System Status"
	W !,?(40-($L(DATETIME)/2)\1),DATETIME
	W !!,?1,"PID/$J",?9,"%CPU",?15,"Device",?32,"Instance",?42,"Routine",?52,"User",?66,"Identity"
	;
	N MSC S MSC="^TMP(""MSCZJOB1"",$J)" K @MSC
	D JOBEXAM^MSCZJOBU(MSC)
	N PID S PID=""
	F  S PID=$O(@MSC@(PID)) Q:PID=""  D
	. I $G(THIS) Q:$$INSTANCE(PID)'=$$CURRENT^ZCD()
	. W !,$$PID(PID)
	. W ?9,$$PCPU(PID)
	. W ?15,$$DEVICE(PID)
	. W ?32,$$INSTANCE(PID)
	. W ?42,$$ROUTINE(PID)
	. W ?52,$$USER(PID)
	. W ?66,$$IDENT(PID)
	K @MSC
	;
	W !! ZSY "uptime"
	Q
	;
PID(PID) ;Return process ID formatted for display
	Q $J(PID,7)_$S($J=PID:"*",1:"")
	;
PCPU(PID) ;Return CPU usage
	Q $J($G(@MSC@(PID,"PCPU")),4)
	;
DEVICE(PID) ;Return device
	N PRI S PRI=$$FIND(PID,"I","$PRINCIPAL")
	Q:PRI'="0" PRI ; FIXME: this could probably be more general
	;
	; look at devices for sockets
	N SOCK S SOCK=$$FIND(PID,"D","        SOCKET[0]")
	I $P(SOCK," ",3)="LISTENING" Q $P($P(SOCK," PORT=",2)," ")_",LISTENING"
	I $P(SOCK," ",3)="CONNECTED" Q $P($P($P(SOCK," LOCAL=",2)," "),"@",2)_",CONNECTED"
	Q ""
	;
INSTANCE(PID) ;Return name of OpenVista instance
	N ZG S ZG=$$FIND(PID,"I","$ZGBLDIR")
	Q $P(ZG,"/",$L(ZG,"/")-2)
	;
ROUTINE(PID) ;Return routine
	Q $P($$FIND(PID,"V","%ZPOS"),"^",2)
	;
USER(PID) ;Return Linux user
	Q $G(@MSC@(PID,"USER"))
	;
IDENT(PID) ;Return OpenVista user
	N DUZ S DUZ=+$$FIND(PID,"V","DUZ")
	N ZG S ZG=$$FIND(PID,"I","$ZGBLDIR")
	Q $P($G(^|ZG|VA(200,DUZ,0)),"^")
	;
FIND(PID,ARR,KEY) ;Return the value of a key in one of the ZSHOW arrays
	N I,X S I="",X=""
	F  S I=$O(@MSC@(PID,ARR,I)) Q:'I  I $P(@MSC@(PID,ARR,I),KEY_"=")="" S X=$TR($P(@MSC@(PID,ARR,I),"=",2,999),"""") Q
	Q X
